package com.zhongzheng.modules.exam.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.common.utils.ServletUtils;
import com.zhongzheng.modules.exam.bo.*;
import com.zhongzheng.modules.exam.vo.ExamNumberGoodsVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.exam.domain.ExamBefore;
import com.zhongzheng.modules.exam.mapper.ExamBeforeMapper;
import com.zhongzheng.modules.exam.vo.ExamBeforeVo;
import com.zhongzheng.modules.exam.service.IExamBeforeService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 前培安排Service业务层处理
 *
 * @author ruoyi
 * @date 2021-12-07
 */
@Service
public class ExamBeforeServiceImpl extends ServiceImpl<ExamBeforeMapper, ExamBefore> implements IExamBeforeService {

    @Override
    public ExamBeforeVo queryById(Long beforeId){
        ExamBeforeVo examBeforeVo = baseMapper.selectByBefore(beforeId);
        List<ExamNumberGoodsVo> examNumberGoodsVos = baseMapper.examNumberGoodsVos(beforeId);
        examBeforeVo.setExamNumberGoods(examNumberGoodsVos);
        return examBeforeVo;
    }

    @Override
    public List<ExamBeforeVo> queryList(ExamBeforeQueryBo bo) {
        return baseMapper.queryBefore(bo);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ExamBeforeVo> entity2Vo(Collection<ExamBefore> collection) {
        List<ExamBeforeVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ExamBeforeVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ExamBefore> page = (Page<ExamBefore>)collection;
            Page<ExamBeforeVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ExamBeforeAddBo bo) {
        ExamBefore add = BeanUtil.toBean(bo, ExamBefore.class);
        validEntityBeforeSave(add);
        add.setCode(ServletUtils.getEncoded("QP"));
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ExamBeforeEditBo bo) {
        ExamBefore update = BeanUtil.toBean(bo, ExamBefore.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ExamBefore entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<ExamNumberGoodsVo> listGoods(ExamNumberGoodsQueryBo bo) {
        return baseMapper.listGoods(bo);
    }

    @Override
    public ExamBeforeVo getGoodsInfo(ExamBeforeQueryBo bo) {
        ExamBeforeVo examBeforeVo = baseMapper.selectByBefore(bo.getBeforeId());
        List<ExamNumberGoodsVo> examNumberGoodsVos = baseMapper.examNumberGoodsVos(bo.getBeforeId());
        examBeforeVo.setExamNumberGoods(examNumberGoodsVos);
        //初始化需要得到的数组
        Long[] array = new Long[examNumberGoodsVos.size()];
        //使用for循环得到数组
        for(int i = 0; i < examNumberGoodsVos.size();i++){
            array[i] = examNumberGoodsVos.get(i).getGoodsId();
        }
        examBeforeVo.setGoodsId(array);
        return examBeforeVo;
    }
}
